part of sf4webgl;

class Framebuffer
{

  static Framebuffer _boundFramebuffer = null;
  
  WebGLFramebuffer _framebuffer;
  
  Framebuffer()
  {
    _framebuffer = _context.createFramebuffer();
  }
  
  void bind()
  {
    if(_boundFramebuffer != this)
    {
      _boundFramebuffer = this;
      _context.bindFramebuffer(WebGLRenderingContext.FRAMEBUFFER, _framebuffer);
    }
  }

  void unbind()
  {
    _boundFramebuffer = null;
    _context.bindFramebuffer(WebGLRenderingContext.FRAMEBUFFER, null);
  }
  
  void attach(Attachment attachment, Renderbuffer renderbuffer)
  {
    bind();
    _context.framebufferRenderbuffer(WebGLRenderingContext.FRAMEBUFFER, attachment._glConst, WebGLRenderingContext.RENDERBUFFER, renderbuffer._renderbuffer);
  }
  
}

class Renderbuffer
{
  
  static Renderbuffer _boundRenderbuffer = null;
  WebGLRenderbuffer _renderbuffer;
  
  Renderbuffer()
  {
    _renderbuffer = _context.createRenderbuffer();
  }
  
  void bind()
  {
    if(_boundRenderbuffer != this)
    {
      _boundRenderbuffer = this;
      _context.bindRenderbuffer(WebGLRenderingContext.RENDERBUFFER, _renderbuffer);
    }
  }
  
  void unbind()
  {
    _boundRenderbuffer = null;
    _context.bindRenderbuffer(WebGLRenderingContext.RENDERBUFFER, 0);
  }

  void storage(InternalFormat internalFormat, int width, int height)
  {
    bind();
    _context.renderbufferStorage(WebGLRenderingContext.RENDERBUFFER, internalFormat._glConst, width, height);
  }
  
}

